
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;


public class calc extends Applet {
  int DECIMAL=2,BINARY=1,HEXEDECIMAL=3,ALL=0;
  int mode=DECIMAL;
  
  public Choice modeChoice;
  public Choice size;
  
  
  public CheckboxGroup txtcolor = new CheckboxGroup();
  public Checkbox Yellow, Green ,  Pink;
  public Checkbox italic, bold;
  String labels[] = {"1/x" ,"Sqrt","x^2","Log",
		     "+/-" ,"Exp" , "Ln","x^y",
		     "D", "E", "F","Clear", 
		     "A", "B", "C", "-", 
                      "7", "8", "9", "+", 
		     "4", "5", "6", "/", 
                      "1", "2", "3", "*", 
		     "0", ".", "PI", "="};
  int modes[]={ 0,0,0,0,
		0,0,0,0,
		3,3,3,0,
		3,3,3,0,
		2,2,2,0,
		2,2,2,0,
		1,2,2,0,
		1,1,0,0
  };
  
  Button b[];
  // Control flags
  boolean newOperand = true;
  
  TextArea T1 ;

  double Operand1 = 0.0;
  double Operand2 = 0.0;
  String operator ;

  
public void init() {


    setLayout(new BorderLayout());
    // Calculator text field

    T1 = new TextArea("0",2,35,TextArea.SCROLLBARS_NONE);
    // Registers required for calculations

    // Add two Panels to the applet
    // One for the display and one for the buttons
    Panel display= new Panel();
    Panel buttons= new Panel();
    Panel p= new Panel();

    buttons.setFont(new Font("Times",Font.BOLD,14));
    display.setBackground(Color.green);
    display.setFont (new Font("Serif",Font.PLAIN,12));
    p.setLayout(new BorderLayout());
    p.setBackground(Color.pink);  
    setLayout(new BorderLayout());
    add(BorderLayout.NORTH,display);
    add(BorderLayout.CENTER,buttons);
    add(BorderLayout.SOUTH,p );


    // Add text entry field to display   
    display.add(T1);
        
    // Add buttons to buttons    
    buttons.setLayout(new GridLayout(8,4,5,5));
    b = new Button[labels.length];
    functionButton fb=new functionButton(this, T1);
    digitButton db=new  digitButton(this, T1);
  
    for (int i = 0 ; i < 32 ; i++) {
      b[i] = new Button(labels[i]);
      if(modes[i]>0)
	b[i].addActionListener(db); 
      else
	b[i].addActionListener(fb);
      buttons.add(b[i]);		
    }
    setButtonColors();
    
    // add mode 
    modeChoice = new Choice();
    modeChoice.setFont(new Font("Times",Font.BOLD,18));
    modeChoice.addItem("                           Binary                    ");
    modeChoice.addItem("                           Decimal                   ");
    modeChoice.addItem("                           Hexadecimal               ");
    modeChoice.select(1);
    modeChoice.addItemListener(new setMode(this));
    p.add(BorderLayout.NORTH,modeChoice );
    
    // add display properties
    Label l=new Label("DISPLAY PROPERTIES");
    l.setBackground(Color.cyan);  
    p.add(BorderLayout.WEST,l );

    Panel properties= new Panel();
    properties.setLayout(new GridLayout(2,3));
    properties.setBackground(Color.cyan);  

    colorChanged cc=new colorChanged(this,display);
    Yellow = new Checkbox("Yellow",txtcolor,true);
    Green=new Checkbox("Green",txtcolor,false);
    Pink = new Checkbox("Pink",txtcolor,false);
    Yellow.addItemListener(cc);
    Green.addItemListener(cc);
    Pink.addItemListener(cc);

    properties.add(Yellow);properties.add(Green);properties.add(Pink);

    fontChanged fc=new fontChanged(this,display);
    bold  = new Checkbox("Bold",false);
    italic=new Checkbox("Italic",false);
    bold.addItemListener(fc);
    italic.addItemListener(fc);

    properties.add(italic);properties.add(bold);
    
    size = new Choice();
    size.addItem("12");
    size.addItem("14");
    size.addItem("16");
    size.addItem("18");
    size.addItem("20");
    size.addItem("22");

    size.addItemListener(fc);
    properties.add(size);
    
    p.add(BorderLayout.CENTER,properties );
     
}
  public void setButtonColors()
  {
    Color activeColor=Color.yellow;
    Color passiveColor=Color.gray;
    for (int i = 0 ; i < 32 ; i++) {
      Color color=( modes[i] <= mode ? activeColor:passiveColor);
      b[i].setBackground(color);  
    }
    if (mode==BINARY || mode==HEXEDECIMAL)
      b[29].setBackground(passiveColor);
    
  }
 public void concatText(String s) {
        if(newOperand) {
                T1.setText("");
                newOperand = false;
        }
	if(s=="." && ( mode==BINARY || mode==HEXEDECIMAL 
		      || (T1.getText().indexOf(".")>=0)))
	  return;
        T1.setText(T1.getText().concat(s));
}
// Handle the operator
public double handleOperator() {
      // Transfer number displayed to register
  Operand2 = getDisplay(); //Double.valueOf(T1.getText()).doubleValue();
      // Do operation
      if (operator=="+")
	Operand1 += Operand2;
      else  if (operator=="-")
	Operand1 -= Operand2;
      else  if (operator=="*")
	Operand1 *= Operand2;
      else  if (operator=="/")
	Operand1 /= Operand2;
      else  if (operator=="x^y")
	Operand1 = Math.pow(Operand1, Operand2);
      else Operand1 = Operand2;
      return Operand1;
}
public void setDisplay(double x)
  {
    int base=10;
    double fbase=0.0;

    if (mode==DECIMAL) {
      T1.setText(String.valueOf(x)); 
      return;
    }
 
    String s= new String(String.valueOf(x));
    int i= s.indexOf('.');
    
    String bd=s;
    String ad="0";
    
    if(i>=0) {
      bd=s.substring(0,i);
      s=s.substring(1+i);
    }
    int bdi=Integer.parseInt(bd);

    String dis="";
    if (mode==BINARY) 
      dis=Integer.toBinaryString(bdi);
    else if (mode==HEXEDECIMAL)
      dis=Integer.toHexString(bdi).toUpperCase();
    T1.setText(dis);
	
  }
public double getDisplay()
  {
    //System.out.print("get disp ");
    int base=10;
    double fbase=0.0;
    if (mode==DECIMAL) 
      return Double.valueOf(T1.getText()).doubleValue();
    else if (mode==BINARY)
      base=2;
    else if (mode==HEXEDECIMAL)
      base=16;
    double x=0;
    String s=T1.getText();
    boolean dot=false;
    for (int i = 0 ; i < s.length() ; i++) {
      if (s.charAt(i)=='.'){
	dot=true;
	fbase=1.0/(double)base;
	continue;
      }
      if (!dot)
	x=x*base+Character.digit(s.charAt(i), base);
      else {
	x+=((double)Character.digit(s.charAt(i), base))*(double)fbase;
	fbase/=base;
      }
    }
    //    System.out.println(x);
    return x;
  }

} // class close


//////////////////////////////////////////////////
//////////////////////////////////////////////////
class  colorChanged implements ItemListener
{
  private calc app;
  private Panel target;
  
 
  public colorChanged(calc  a , Panel t) { app = a;  target=t; }

  public void itemStateChanged(ItemEvent e)
  {
    if(app.Yellow.getState())
      target.setBackground(Color.yellow); 
    else if (app.Green.getState())
      target.setBackground(Color.green); 
    else if (app.Pink.getState())
      target.setBackground(Color.pink); 
  }
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
class  fontChanged implements ItemListener
{
  private calc app;
 private Panel target;
 
  public fontChanged(calc  a , Panel t) { app = a;  target=t; }

  public void itemStateChanged(ItemEvent e)
  {
    int valBold=(app.bold.getState() ? Font.BOLD: Font.PLAIN);
    int valItalic=(app.italic.getState() ? Font.ITALIC: Font.PLAIN);
    int val=valBold+valItalic;
    int size=Integer.parseInt(app.size.getSelectedItem());
    target.setFont (new Font("Serif",val,size));
   
    target.repaint();
  }
}


//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
class  setMode implements ItemListener
{
  private calc applet;
 
 
  public setMode(calc a) { applet = a; }

  public void itemStateChanged(ItemEvent e)
  {
    double x=applet.getDisplay();
    applet.mode=applet.modeChoice.getSelectedIndex()+1;
    applet.setButtonColors();
    applet.setDisplay(x);
  }
}



//////////////////////////////////////////////////
//////////////////////////////////////////////////
class  digitButton implements ActionListener
{
  private calc applet;
  private TextArea field;
 
  public digitButton(calc a, TextArea t) { applet = a; field = t; }

  public void actionPerformed(ActionEvent e)
  {
    String s= e.getActionCommand();
    int i;
    try {
       i=Integer.parseInt(s);
    } catch (Exception ex){
	if (  applet.mode== applet.DECIMAL && s.equals(".") )
	  i=5;
	else 	i=11;

    }
    if ((applet.mode== applet.BINARY && i>1) || (applet.mode== applet.DECIMAL && i>9))
      return;
    applet.concatText(s);
  }///
}


//////////////////////////////////////////////////
//////////////////////////////////////////////////
class  functionButton implements ActionListener
{
  private calc applet;
  private TextArea field;
 
  public functionButton(calc a, TextArea t) { applet = a; field = t; }

  public void actionPerformed(ActionEvent e)
  {
      boolean flag = false;
      double x = 0;
      double y = 0;
    
      try {
	y = applet.getDisplay(); //Double.valueOf(applet.T1.getText()).doubleValue();
      }
      catch (Exception ex) {
	// Do nothing
      }
	
      String pressed=e.getActionCommand();
      if(pressed=="PI") {
	x = Math.PI;
      }
      else if(pressed=="Clear") {
	applet.newOperand = true;
	applet.Operand1=0.0;
	applet.operator="=";
	applet.T1.setText("0");
	return;
      }
      else if(pressed=="+/-") {
	x = -1 * y;
      }
      else if(pressed=="Sqrt") {
	x = Math.sqrt(y);
      }
      else if(pressed=="x^2") {
	x = y*y;
      }
      else if(pressed=="Log") {
	x = Math.log(y)/Math.log(10);
      }
      else if(pressed=="1/x") {
	x = 1/y;
      }
      else if(pressed=="Exp") {
	x = Math.exp(y);
      }
      else if(pressed=="Ln") {
	x = Math.log(y);
      }
      else if(pressed=="=") 
	x = applet.handleOperator();
      else  {
	applet.operator=pressed;
	x=y  ;//Double.valueOf(applet.T1.getText()).doubleValue();
      }
      applet.newOperand = true;
      applet.Operand1=x;
      if(x==0.0) {
	applet.T1.setText("0");
      }
      else {
	applet.setDisplay(x); 
      }
  }// func
}


